""" SS 2012
    ALP2 Team
    
    5th Homework
"""
# 2nd Task

"""
  a) Schreiben Sie eine Funktion, die aus einem beliebigen Text die Woerter,
     die sich in den letzten drei Buchstaben reimen, in einer Liste von
     Gruppenwoertern organisiert. 
     
     Beispiel:
     Eingabe:  "Klaus baut ein Haus und klaut vom Nachbarn Strom."
     Ausgabe:  [ [Klaus, Haus], [baut, klaut], ['ein'], ['und'], ['vom'], ... ]
"""

def elim_punctuation (text):
    """ Filtert alle Zeichen die keine Buchstaben oder Leerzeichen sind. """
    only_letters_and_spaces = [char for char in text if char.isalpha() or char == ' ']
    
    return "".join(only_letters_and_spaces) # put the list of letters together in a string

def rhyme_words (text):
    """ Zerlegt einen Text in Listen von Listen, die die Woerter
        nach den letzten drei Buchstaben gruppiert. Woerte mit
        weniger als drei Buchstaben werden ignoriert.
    """
    words = elim_punctuation(text.replace("\n"," ")).lower().split(" ")
    
    rhyme_words = {}
    
    for word in words:
        if len(word) >= 3: # Woerte mit weniger als 3 Buchstaben werden ignoriert
            suffix = word[-3:]
            if suffix in rhyme_words:
                if not word in rhyme_words[suffix]:
                    rhyme_words[suffix].append(word)
            else:
                rhyme_words[suffix] = [word]
                
    return list(rhyme_words.values())


oscar_wild = """I can write no stately proem
                As a prelude to my lay;
                From a poet to a poem
                I would dare to say.

                For if of these fallen petals
                One to you seem fair,
                Love will waft it till it settles
                On your hair.

                And when wind and winter harden
                All the loveless land,
                It will whisper of the garden,
                You will understand.
         """
print(rhyme_words(oscar_wild))


# 3rd Task
"""
  Implementieren Sie den iterativen Algorithmus fuer die Loesung des Hanoi-Turm-
  Problems, wie in der Vorlesung besprochen.
"""
""" Diese Hanoi-Funktionen arbeiten mit dem yield statement. Wem das nicht
    geheuer ist kann es einfach als "print" lesen (oder auch dadurch
    ersetzen). Durch das Zusammenspiel von `run_hanoi` und `yield` wird
    die Ausgabe verzoegert bis sie gebraucht wird (Bedarfsauswertung).
    Funktioniert wie lazy evaluation in Haskell.

    Read about it here: (Schlagwoerter: Generators, Iterators)
    http://docs.python.org/py3k/reference/simple_stmts.html#yield """

def hanoi(n):
    """ Umsetzung des iterativen Algorithmus zur LÃ¶sung des TÃ¼rme von Hanoi
        Problems wie in den Vorlesungfolien. Es werden drei Stapel modelliert
        (Python-Listen lassen sich dank der Methoden `append` und `pop` als
        Stapel benutzen). """

    A, B, C = [i for i in range(n, 0, -1)], [], []

    if n % 2 == 0:
        B.append(A.pop())
        yield (1, 'A', 'B', A, B, C)
    else:
        C.append(A.pop())
        yield (1, 'A', 'C', A, B, C)

    steps = 1
    while len(C) != n:
        """ Sobald der Zielstapel voll ist bricht die Schleife ab. """

        """ (1) Der einzig moegliche Zug wird ermittelt und durchgefuehrt.
                Kann auch eleganter programmiert werden, indem eine Schleife
                benutzt wird die wechselweise alle Stapel Ueberprueft. """
        if len(C) > 0 and C[-1] == 1:
            if len(B) > 0 < len(A) and B[-1] > A[-1] or len(B) == 0:
                B.append(A.pop())
                yield (B[-1], 'A', 'B', A, B, C)
            elif len(B) > 0 < len(A) and B[-1] < A[-1] or len(A) == 0:
                A.append(B.pop())
                yield (A[-1], 'B', 'A', A, B, C)
        elif len(A) > 0 and A[-1] == 1:
            if len(B) > 0 < len(C) and B[-1] > C[-1] or len(B) == 0:
                B.append(C.pop())
                yield (B[-1], 'C', 'B', A, B, C)
            elif len(B) > 0 < len(C) and B[-1] < C[-1] or len(C) == 0:
                C.append(B.pop())
                yield (C[-1], 'B', 'C', A, B, C)
        else:
            if len(A) > 0 < len(C) and A[-1] > C[-1] or len(A) == 0:
                A.append(C.pop())
                yield (A[-1], 'C', 'A', A, B, C)
            elif len(A) > 0 < len(C) and A[-1] < C[-1] or len(C) == 0:
                C.append(A.pop())
                yield (C[-1], 'A', 'C', A, B, C)

        """ (2) Die kleinste Scheibe wird verlegt. Die Scheibe ist immer
                auf dem Uebernaechsten Stab am laengsten nicht gewesen, allerdings
                muss man fuer ungerade Zahlen in Richtung A -> B -> C rotieren,
                fuer gerade in Richtung B -> A -> C """
        if len(A) > 0 and A[-1] == 1:
            C.append(A.pop()) if n % 2 != 0 else B.append(A.pop())
            yield (1, 'A', 'C', A, B, C)
        elif len(B) > 0 and B[-1] == 1:
            A.append(B.pop()) if n % 2 != 0 else C.append(B.pop())
            yield (1, 'B', 'C', A, B, C)
        else:
            B.append(C.pop()) if n % 2 != 0 else A.append(C.pop())
            yield (1, 'C', 'B', A, B, C)

def hanoi_binary(n):
    """ Eine wesentlich kuerzere Implementierung (nicht gefordert) die
        mit binaeren Operationen die Zugfolgen direkt aus der Zugnummer
        konstruiert. Ebenfalls iterativ.

        Quelle: http://obelix.ee.duth.gr/~apostolo/TowersOfHanoi/

        (modifiziert um in jedem Schritt die aktuellen Stabbelegungen
         verfuegbar zu haben). """

    A, B, C = [i for i in range(n, 0, -1)], [], []
    if n % 2 == 0:
        towers, names = (A, C, B), ('A', 'C', 'B')
    else:
        towers, names = (A, B, C), ('A', 'B', 'C')

    x = 1
    while x < (1 << n):
        from_ = ( x & (x - 1)) % 3
        to    = ((x | (x - 1)) + 1) % 3
        towers[to].append(towers[from_].pop())

        yield (towers[to][-1], names[from_], names[to], A, B, C)              
        x += 1

def run_hanoi(n, hanoi_func = hanoi):
    """ Benutzt eine der beiden hanoi-Funktionen (hanoi oder hanoi_binary)
        und gibt die Schritte und aktuellen Belegungen aus.

        Wenn die Funktionen zu lange laufen (laenger als die optimale
        Anzahl von 2**n-1 Schritten) wird die Schleife mit einem
        AssertionError abgebrochen (terminiert also auch bei Fehlern). """

    steps = 0
    for (v, o, d, A, B, C) in hanoi_func (n):
        steps += 1
        print ("Bewege", v, "von", o, "nach", d)
        print (A, B, C)
        assert steps <= 2 ** n - 1

def test_hanoi(hanoi_func = hanoi, problem_sizes = range(3, 8)):
    """ Testet eine der Hanoi-Funktionen auf Korrektheit, wobei lediglich
        geprueft wird ob die Anzahl der Schritte korrekt ist (nicht ob die
        einzelnen Schritte korrekt sind). """

    for n in problem_sizes:
        steps = 0
        for (v, o, d, A, B, C) in hanoi_func (n):
            steps += 1
            if steps > 2 ** n - 1:
                break
        print (n, steps)
        assert steps == 2 ** n - 1
    print ("Funktioniert!")

test_hanoi()

# 4th Task
"""
 Schreiben Sie eine Variante des Algorithmus von Erathostenes, der anstatt ein 
 Array von boolschen Werten ein Array von Bytes verwendet. Die Bits der Zahlen 
 sollen fuer das Markieren der Primzahlen verwendet werden. Auf diese Art und 
 Weise kann der Wertbereich der suchenden Primzahlen um einem Faktor von 8 
 erhoeht werden.
"""

from math import sqrt

def erathostenes (sieve_size = 100):
    """ Sieb des Erathostenes mit Speicherung in Bitmasken. """

    if sieve_size <= 2:
        return []

    sieve = [0b11111111 for _ in range(sieve_size // 8 + 1)]
    sieve[0] = 0b11111100

    for i in range(2, int(sqrt(sieve_size))+2):
        if sieve[i // 8] & (1 << (i % 8)) != 0:
            for j in range(2*i, sieve_size+1, i):
                sieve[j // 8] &= 0b11111111 ^ (1 << (j % 8))
                # hier darf nicht einfach ^= verwendet werden,
                # da sonst ausgeschlossene Zahlen wieder eingeschlossen
                # werden koennen.

    primes = []
    for i in range(0, sieve_size+1):
        if sieve[i // 8] & (1 << (i % 8)) != 0:
            primes.append(i)

    return primes

def test_erathostenes (sieve_size = 10000):
    primes = erathostenes (sieve_size)
    for p in primes:
        for divisor in range(2, p):
            assert p % divisor != 0
    print ("Alle gefundenen Zahlen *sind* Primzahlen.")

test_erathostenes(100)

# 5th Task
"""
 Schreiben Sie eine Python-Funktion, die mit linearem Aufwand bezueglich der
 Anzahl von Pixeln in einem Schwarz/Weiss-Bild das groesste schwarze Quadrat
 innerhalb des Bildes findet. Das Bild wird mit einer Matrix aus Nullen und
 Einsen dargestellt, wobei 0 fuer weiss und 1 fuer schwarz steht. 

 Das Ergebnis soll in einem Tupel aus zwei Tupeln zurueckgegeben werden,
 die der oberen linken  und die unteren rechten Koordinate des Quadrates
 entspricht.
"""
def find_largest_square (matrix):
    """ Findet das grÃ¶ÃŸte Quadrat von Einsen in einer rechteckigen Matrix.

        Mithilfe einer Hilfsmatrix `helper` wird sich fuer jede Position
        gemerkt, ob sie Teil eines Quadrats ist (ob also oben, links, und
        oben links ein Wert ungeleich null steht). Hierfuer werden zunaechst
        die erste und zweite Spalte in die Hilfsmatrix kopiert, dann wird
        fuer die verbleibenden Felder ermittelt ob sie in einem Quadrat liegen.

        In der Hilfsmatrix wird auch vermerkt, wie gross das Quadrat bis
        zu dieser Stelle ist. Der groesste Wert markiert die untere rechte
        Ecke des jeweiligen Quadrats. """

    m, n = len(matrix), len(matrix[0])
    helper = [[0 for n in range(0, n)] for i in range(0, m)]

    for i in range(0, m):
        helper[i][1] = matrix[i][1]
    for j in range(0, n):
        helper[1][j] = matrix[1][j]
    
    maximum = 0
    for i in range(1, m):
        for j in range(1, n):
            if matrix[i][j]:
                helper[i][j] = 1 + min( helper[i-1][j]
                                      , helper[i-1][j-1]
                                      , helper[i][j-1] )
                if helper[i][j] > maximum:
                    maximum = helper[i][j]
                    x, y = i, j
            else:
                helper[i][j] = 0

    return ((x - maximum + 1, y - maximum + 1), (x, y))

""" Die Beispiel-Eingabe aus der Aufgabenstellung. """
square = [ [ 0, 0, 1, 1, 0, 1, 1, 1, 0, 0, 0, 0, 0 ]
         , [ 0, 0, 1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 0 ]
         , [ 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0 ]
         , [ 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0 ]
         , [ 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 0 ]
         , [ 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0 ]
         , [ 0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0 ] ]

def test_largest_square (matrix = square):
    assert find_largest_square (matrix) == ((1, 6), (4, 9))
    print ("Das Beispiel funktioniert.")

test_largest_square()
